variables:
  IMAGE_TAG: "v4.20"

hadolint:
  stage: build
  timeout: 10m
  image: hadolint/hadolint:v2.12.0-debian
  script:
    - hadolint Dockerfile
  rules:
    - if: '$CI_MERGE_REQUEST_TARGET_BRANCH_NAME == "main"'

test-docker-build:
  stage: test
  timeout: 10m
  image: docker:24.0.7-cli-alpine3.18
  variables:
    DOCKER_HOST: tcp://docker:2375
    DOCKER_TLS_CERTDIR: ""
  services:
    - name: docker:24.0.7-dind-alpine3.18
  script:
    - cat Dockerfile
    - docker build --build-arg IMAGE_TAG=${IMAGE_TAG} .
    - docker image ls
  rules:
    - if: '$CI_MERGE_REQUEST_TARGET_BRANCH_NAME == "main"'

docker:
  stage: deploy
  image: docker:24.0.7-cli-alpine3.18
  variables:
    DOCKER_IMAGE: $CI_REGISTRY_IMAGE:${CI_COMMIT_TAG}
    DOCKER_IMAGE_LATEST: $CI_REGISTRY_IMAGE:latest
    DOCKER_IMAGE_FULL: $CI_REGISTRY_IMAGE:${IMAGE_TAG}
    DOCKER_HOST: tcp://docker:2375
    DOCKER_TLS_CERTDIR: ""
  services:
    - name: docker:24.0.7-dind-alpine3.18
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - cat Dockerfile
    - docker build --build-arg IMAGE_TAG=${IMAGE_TAG} --tag ${DOCKER_IMAGE_FULL} --tag ${DOCKER_IMAGE} --tag ${DOCKER_IMAGE_LATEST} .
    - docker image ls
    - docker push ${DOCKER_IMAGE_FULL}
    - docker push ${DOCKER_IMAGE}
    - docker push ${DOCKER_IMAGE_LATEST}
    - echo "Ready docker image ${DOCKER_IMAGE_FULL}, ${DOCKER_IMAGE} and ${DOCKER_IMAGE_LATEST}"
  after_script:
    - docker logout $CI_REGISTRY
  rules:
    - if: $CI_COMMIT_TAG
